import classNames from 'classnames';
import React, { useMemo } from 'react';
import Styles from './style.less';

export default (props) => {
  const { className, checked, label, color, onChange } = props;

  const classList = useMemo(
    () => classNames(Styles['c-radio'], className, { [Styles['active']]: checked }),
    [className, checked],
  );

  const signStyle = useMemo(() => {
    return { borderColor: color };
  }, [color]);

  const pointerStyle = useMemo(() => {
    return { background: checked ? color : 'transparent' };
  }, [color, checked]);

  const handleClick = () => {
    if (typeof onChange === 'function') {
      onChange(true); // radio 只有选中状态
    }
  };

  return (
    <div className={classList} onClick={handleClick}>
      <span className={Styles['check-sign']} style={signStyle}>
        <span className={Styles['check-sign-pointer']} style={pointerStyle} />
      </span>
      <span className={Styles['label']}>{label}</span>
    </div>
  );
};
