import React, { useState, useEffect, useRef } from 'react';
import { Button, Popconfirm, Modal, Form, Input, message } from 'antd';
import { PageHeaderWrapper } from '@ant-design/pro-layout';
import PageTable from '@/components/PageTable';

export default (props) => {
  const formItemLayout = { labelCol: { span: 6 }, wrapperCol: { span: 14 } };
  const [form] = Form.useForm();
  const [editModal, setEditModal] = useState(false);
  const [loading, setLoading] = useState(false);
  const [regionId, setRegionId] = useState();
  const actionRef = useRef();

  const dataSource = [
    {
      key: '1',
      name: '监控记录仪',
      createDate: '2022-06-05',
      status: '',
    },
    {
      key: '2',
      name: '深松传感器',
      createDate: '2022-03-27',
      status: '',
    },
    {
      key: '3',
      name: '无人机设备',
      createDate: '2022-03-13',
      status: '',
    },
    {
      key: '4',
      name: '',
      createDate: '2022-03-13',
      status: '',
    },
    {
      key: '5',
      name: '',
      createDate: '2022-03-13',
      status: '',
    },
  ];

  const columns = [
    {
      title: '分类名',
      dataIndex: 'name',
      key: 'name',
    },
    {
      title: '创建时间',
      dataIndex: 'createDate',
      key: 'createDate',
      search: false,
      width: 340,
    },
    {
      title: '状态',
      dataIndex: 'status',
      key: 'status',
      search: false,
    },
  ];

  return (
    <PageHeaderWrapper>
      <PageTable
        columns={columns}
        dataSource={dataSource}
        actionRef={actionRef}
        options={false}
        // toolBarRender={actions}
        scroll={{ x: 1000 }}
      />
    </PageHeaderWrapper>
  );
};
